﻿/*
 POINTAGE.SQF
 ===========
 version 1.0 (11.10.2009)  © Pumpkin of M.O.S
 
 Pointage et repérage de tout véhicle au sol avec les jumelles. Dés le répèrage, le véhicle apparait sur la carte de tous les membres du groupe (Reveal)
 
 Paramètres :
 ------------
 [membre_du_groupe (, script_associé)]  execVM "Patrols.sqf"
 
 remarques :
 ® Deux variables globales sont mis à jour :
   - BinoPos : renvoi soit la position "au sol" (légèrement sous le centre), soit celle du véhicle repéré/pointé
   - BinoCenter : renvoi la position strictement au centre de la jumelle (utile par exemple pour la téléportation par jumelle)
 
*/

if (isMultiplayer and (not isServer)) exitwith {};

player commandchat "Lancement de scripts en local";

_joueur = _this select 0;
//_oldobj = objNull;
_oldobj = _joueur;

_script = "";
if (count _this > 1) then { _script = _this select 1 };

player groupchat format ["_joueur %1 script %2",_joueur];

_wpos = [0,0,0];
BinoPos = [-1,-1,-1];
BinoCenter = [0,0,0];

_cnt = 0;

for [{_infinite=0},{_infinite<=1},{_infinite=_infinite+1}] do {
	
	waituntil {currentWeapon player == "BINOCULAR"};
	// Attendre la fin de l'anim "prise de jumelle"
	sleep 3.5;
	
	if (_script != "") then {execVM _script};
	
	while {currentWeapon player == "BINOCULAR"} do {
		
		_wpos = screenToWorld [0.5,0.55];
		BinoCenter = screenToWorld [0.5,0.5];

		_nobj = nearestObjects [_wpos,["AllVehicles"],100];
		_pointage = false;
		_obj = objnull;
		
		for [{_i = 0},{_i < count _nobj},{_i = _i + 1}] do {
			
			_obj = _nobj select _i;
			
			_posplx = getpos player select 0;
			_posply = getpos player select 1;
			_posobjx = getpos _obj select 0;
			_posobjy = getpos _obj select 1;
			
			_dx = _posobjx - _posplx;
			_dy = _posobjy - _posply;
			
			_deg = _dx atan2 _dy;
			if (_deg < 0) then {_deg = 360 + _deg};
			_dir = direction player;
			// Vérifier si un autre véhicle est pointé
			if ( (_deg < (_dir + 0.5)) and (_deg > (_dir - 0.5)) ) then {
				if ((_obj != _joueur) and (alive _obj)) then {
					(group _joueur) reveal _obj;
					// BinoPos modifié = position du véhicle			
					BinoPos = [getpos _obj select 0, getpos _obj select 1, 0];
					_pointage = true;
				};
			};
			if (_pointage) exitwith {};
			sleep 0.01;
		};


		// Si aucun véhicle n'est pointé, prendre les coordonnées par défaut
		if (not _pointage) then {
			// BinoPos par défaut = légèrement sous le centre			
			BinoPos = [_wpos select 0, _wpos select 1, -1];
		}
		else {
			if (_oldobj != _obj) then { _cnt = 0 };
			// Ne pas parler trop souvent...
			if (_cnt == 0) then { _joueur groupchat format ["%1 repéré !",typeof _obj] };
			_cnt = _cnt + 1;
			if (_cnt > 5) then { _cnt = 0};
			
			_oldobj = _obj;
		};
		sleep 2;
		
	};

	sleep 0.5;
	_infinite = 0;

};
